VTK: vtkImplicitSelectionLoop Class Reference

| VTK 9.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkImplicitSelectionLoop Class Reference

implicit function for a selection loop More...

`#include <vtkImplicitSelectionLoop.h>`

Inheritance diagram for vtkImplicitSelectionLoop:
[legend]
Collaboration diagram for vtkImplicitSelectionLoop:
[legend]

## Public Member Functions
void | EvaluateGradient (double x[3], double n[3]) override
| Evaluate selection loop returning the gradient. More...
vtkMTimeType | GetMTime () override
| Overload GetMTime() because we depend on the Loop. More...
double | EvaluateFunction (double x[3]) override
| Evaluate selection loop returning a signed distance. More...
virtual double | EvaluateFunction (double x[3])=0
| Evaluate selection loop returning a signed distance. More...
virtual void | EvaluateFunction (vtkDataArray *input, vtkDataArray *output)
| Evaluate selection loop returning a signed distance. More...
virtual double | EvaluateFunction (double x, double y, double z)
| Evaluate selection loop returning a signed distance. More...
virtual void | SetLoop (vtkPoints *)
| Set/Get the array of point coordinates defining the loop. More...
virtual vtkPoints * | GetLoop ()
| Set/Get the array of point coordinates defining the loop. More...
virtual void | SetAutomaticNormalGeneration (vtkTypeBool)
| Turn on/off automatic normal generation. More...
virtual vtkTypeBool | GetAutomaticNormalGeneration ()
| Turn on/off automatic normal generation. More...
virtual void | AutomaticNormalGenerationOn ()
| Turn on/off automatic normal generation. More...
virtual void | AutomaticNormalGenerationOff ()
| Turn on/off automatic normal generation. More...
virtual void | SetNormal (double, double, double)
| Set / get the normal used to determine whether a point is inside or outside the selection loop. More...
virtual void | SetNormal (double[3])
| Set / get the normal used to determine whether a point is inside or outside the selection loop. More...
virtual double * | GetNormal ()
| Set / get the normal used to determine whether a point is inside or outside the selection loop. More...
virtual void | GetNormal (double data[3])
| Set / get the normal used to determine whether a point is inside or outside the selection loop. More...
Public Member Functions inherited from vtkImplicitFunction
vtkImplicitFunction * | NewInstance () const
virtual void | FunctionValue (vtkDataArray *input, vtkDataArray *output)
| Evaluate function at position x-y-z and return value. More...
double | FunctionValue (const double x[3])
| Evaluate function at position x-y-z and return value. More...
double | FunctionValue (double x, double y, double z)
| Evaluate function at position x-y-z and return value. More...
void | FunctionGradient (const double x[3], double g[3])
| Evaluate function gradient at position x-y-z and pass back vector. More...
double * | FunctionGradient (const double x[3])
| Evaluate function gradient at position x-y-z and pass back vector. More...
double * | FunctionGradient (double x, double y, double z)
| Evaluate function gradient at position x-y-z and pass back vector. More...
virtual void | SetTransform (vtkAbstractTransform *)
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual void | SetTransform (const double elements[16])
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual vtkAbstractTransform * | GetTransform ()
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual void | EvaluateFunction (vtkDataArray *input, vtkDataArray *output)
| Evaluate function at position x-y-z and return value. More...
virtual double | EvaluateFunction (double x, double y, double z)
| Evaluate function at position x-y-z and return value. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkImplicitSelectionLoop * | New ()
| Instantiate object with no initial loop. More...
Static Public Member Functions inherited from vtkImplicitFunction
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImplicitFunction * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkImplicitSelectionLoop ()
| ~vtkImplicitSelectionLoop () override
Protected Member Functions inherited from vtkImplicitFunction
| vtkImplicitFunction ()
| ~vtkImplicitFunction () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkPoints * | Loop
double | Normal [3]
vtkTypeBool | AutomaticNormalGeneration
Protected Attributes inherited from vtkImplicitFunction
vtkAbstractTransform * | Transform
double | ReturnValue [3]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkImplicitFunction | Superclass
| Standard VTK methods for printing and type information. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard VTK methods for printing and type information. More...
static vtkImplicitSelectionLoop * | SafeDownCast (vtkObjectBase *o)
| Standard VTK methods for printing and type information. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard VTK methods for printing and type information. More...
vtkImplicitSelectionLoop * | NewInstance () const
| Standard VTK methods for printing and type information. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard VTK methods for printing and type information. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard VTK methods for printing and type information. More...

## Additional Inherited Members
Public Types inherited from vtkImplicitFunction
typedef vtkObject | Superclass
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

implicit function for a selection loop

vtkImplicitSelectionLoop computes the implicit function value and function gradient for an irregular, cylinder-like object whose cross section is defined by a set of points forming a loop. The loop need not be convex nor its points coplanar. However, the loop must be non-self-intersecting when projected onto the plane defined by the accumulated cross product around the loop (i.e., the axis of the loop). (Alternatively, you can specify the normal to use.)

The following procedure is used to compute the implicit function value for a point x. Each point of the loop is first projected onto the plane defined by the loop normal. This forms a polygon. Then, to evaluate the implicit function value, inside/outside tests are used to determine if x is inside the polygon, and the distance to the loop boundary is computed (negative values are inside the loop).

One example application of this implicit function class is to draw a loop on the surface of a mesh, and use the loop to clip or extract cells from within the loop. Remember, the selection loop is "infinite" in length, you can use a plane (in boolean combination) to cap the extent of the selection loop. Another trick is to use a connectivity filter to extract the closest region to a given point (i.e., one of the points used to define the selection loop).

See also
  vtkImplicitFunction vtkImplicitBoolean vtkExtractGeometry vtkClipPolyData vtkConnectivityFilter vtkPolyDataConnectivityFilter

Online Examples:

Tests:
  vtkImplicitSelectionLoop (Tests)

Definition at line 58 of file vtkImplicitSelectionLoop.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkImplicitFunction vtkImplicitSelectionLoop::Superclass

Standard VTK methods for printing and type information.

Definition at line 65 of file vtkImplicitSelectionLoop.h.

## Constructor & Destructor Documentation

## ◆ vtkImplicitSelectionLoop()

vtkImplicitSelectionLoop::vtkImplicitSelectionLoop | ( |  | ) |
| protected

## ◆ ~vtkImplicitSelectionLoop()

vtkImplicitSelectionLoop::~vtkImplicitSelectionLoop | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkImplicitSelectionLoop::IsTypeOf | ( | const char * | type | ) |
| static

Standard VTK methods for printing and type information.

## ◆ IsA()

virtual vtkTypeBool vtkImplicitSelectionLoop::IsA | ( | const char * | type | ) |
| virtual

Standard VTK methods for printing and type information.

Reimplemented from vtkImplicitFunction.

## ◆ SafeDownCast()

static vtkImplicitSelectionLoop* vtkImplicitSelectionLoop::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard VTK methods for printing and type information.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkImplicitSelectionLoop::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard VTK methods for printing and type information.

Reimplemented from vtkImplicitFunction.

## ◆ NewInstance()

vtkImplicitSelectionLoop* vtkImplicitSelectionLoop::NewInstance | ( |  | ) | const

Standard VTK methods for printing and type information.

## ◆ PrintSelf()

void vtkImplicitSelectionLoop::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard VTK methods for printing and type information.

Reimplemented from vtkImplicitFunction.

## ◆ New()

static vtkImplicitSelectionLoop* vtkImplicitSelectionLoop::New | ( |  | ) |
| static

Instantiate object with no initial loop.

## ◆ EvaluateFunction() [1/4]

double vtkImplicitSelectionLoop::EvaluateFunction | ( | double | x[3] | ) |
| overridevirtual

Evaluate selection loop returning a signed distance.

Implements vtkImplicitFunction.

## ◆ EvaluateGradient()

void vtkImplicitSelectionLoop::EvaluateGradient | ( | double | x[3],
|  | double | n[3]
| ) |  |
| overridevirtual

Evaluate selection loop returning the gradient.

Implements vtkImplicitFunction.

## ◆ SetLoop()

virtual void vtkImplicitSelectionLoop::SetLoop | ( | vtkPoints * |  | ) |
| virtual

Set/Get the array of point coordinates defining the loop.

There must be at least three points used to define a loop.

## ◆ GetLoop()

virtual vtkPoints* vtkImplicitSelectionLoop::GetLoop | ( |  | ) |
| virtual

Set/Get the array of point coordinates defining the loop.

There must be at least three points used to define a loop.

## ◆ SetAutomaticNormalGeneration()

virtual void vtkImplicitSelectionLoop::SetAutomaticNormalGeneration | ( | vtkTypeBool |  | ) |
| virtual

Turn on/off automatic normal generation.

By default, the normal is computed from the accumulated cross product of the edges. You can also specify the normal to use.

## ◆ GetAutomaticNormalGeneration()

virtual vtkTypeBool vtkImplicitSelectionLoop::GetAutomaticNormalGeneration | ( |  | ) |
| virtual

Turn on/off automatic normal generation.

By default, the normal is computed from the accumulated cross product of the edges. You can also specify the normal to use.

## ◆ AutomaticNormalGenerationOn()

virtual void vtkImplicitSelectionLoop::AutomaticNormalGenerationOn | ( |  | ) |
| virtual

Turn on/off automatic normal generation.

By default, the normal is computed from the accumulated cross product of the edges. You can also specify the normal to use.

## ◆ AutomaticNormalGenerationOff()

virtual void vtkImplicitSelectionLoop::AutomaticNormalGenerationOff | ( |  | ) |
| virtual

Turn on/off automatic normal generation.

By default, the normal is computed from the accumulated cross product of the edges. You can also specify the normal to use.

## ◆ SetNormal() [1/2]

virtual void vtkImplicitSelectionLoop::SetNormal | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set / get the normal used to determine whether a point is inside or outside the selection loop.

## ◆ SetNormal() [2/2]

virtual void vtkImplicitSelectionLoop::SetNormal | ( | double | [3] | ) |
| virtual

Set / get the normal used to determine whether a point is inside or outside the selection loop.

## ◆ GetNormal() [1/2]

virtual double* vtkImplicitSelectionLoop::GetNormal | ( |  | ) |
| virtual

Set / get the normal used to determine whether a point is inside or outside the selection loop.

## ◆ GetNormal() [2/2]

virtual void vtkImplicitSelectionLoop::GetNormal | ( | double | data[3] | ) |
| virtual

Set / get the normal used to determine whether a point is inside or outside the selection loop.

## ◆ GetMTime()

vtkMTimeType vtkImplicitSelectionLoop::GetMTime | ( |  | ) |
| overridevirtual

Overload GetMTime() because we depend on the Loop.

Reimplemented from vtkImplicitFunction.

## ◆ EvaluateFunction() [2/4]

virtual double vtkImplicitFunction::EvaluateFunction

Evaluate selection loop returning a signed distance.

## ◆ EvaluateFunction() [3/4]

virtual void vtkImplicitFunction::EvaluateFunction

Evaluate selection loop returning a signed distance.

## ◆ EvaluateFunction() [4/4]

virtual double vtkImplicitFunction::EvaluateFunction
| inline

Evaluate selection loop returning a signed distance.

Definition at line 121 of file vtkImplicitFunction.h.

## Member Data Documentation

## ◆ Loop

vtkPoints* vtkImplicitSelectionLoop::Loop
| protected

Definition at line 125 of file vtkImplicitSelectionLoop.h.

## ◆ Normal

double vtkImplicitSelectionLoop::Normal[3]
| protected

Definition at line 126 of file vtkImplicitSelectionLoop.h.

## ◆ AutomaticNormalGeneration

vtkTypeBool vtkImplicitSelectionLoop::AutomaticNormalGeneration
| protected

Definition at line 127 of file vtkImplicitSelectionLoop.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkImplicitSelectionLoop.h